#include <cstdio>
#include <thread>
#include <chrono>
#include <unistd.h>
#include <signal.h>

#include <executionclient.hpp>
#include <phmclient.hpp>
#include "logger.hpp"

// Creating bool variable as flag to control while loop
static bool isRunning = true;

void sigterm_handler(int signum) {
printf("Received signal : %d\n", signum);
// Do any necessary cleanup here

// Setting flag value to false when signal received.
isRunning = false;
}

int main(int argc, char ** argv) {
    (void) argc;
    (void) argv;
    uint32_t incrementVar = 0U;

    signal(SIGTERM, sigterm_handler);

    printf("hello world my_package package\n");
    printf("CPP process ID : %d\n", getpid());
    printf("CPP parent process ID : %d\n", getppid());

    nebula::platform::Logger logger_ { nebula::platform::Logger("my_node") };
    auto &execClient = nebula::exec::client::ExecutionClient::getInstance(nebula::exec::client::ApplicationType::APP_TYPE_ROS);
    auto &phmClient = nebula::phm::client::PHMClient::getInstance(nebula::phm::client::ApplicationType::APP_TYPE_ROS);


    execClient.reportExecutionState(nebula::exec::client::ExecutionState::ESRunning);


    while (isRunning) {
        usleep(300*1000);
        phmClient.reportCheckPoint(11);
        printf("my node sleep at position : %d\n", incrementVar);
        logger_.LogDebug() << "[my_node::main] my node sleep at position :" << incrementVar++;
    }

    execClient.reportExecutionState(nebula::exec::client::ExecutionState::ESTerminated);

    printf("my_node: At End of ROS application\n");

    return 0;
}
